Codeforces Beta Round #10 D. LCIS 动态规划

D. LCIS

题目连接:

http://www.codeforces.com/contest/10/problem/D

Description

This problem differs from one which was on the online contest.

The sequence a1, a2, ..., an is called increasing, if ai < ai + 1 for i < n.

The sequence s1, s2, ..., sk is called the subsequence of the sequence a1, a2, ..., an, if there exist such a set of indexes 1 ≤ i1 < i2 < ... < ik ≤ n that aij = sj. In other words, the sequence s can be derived from the sequence a by crossing out some elements.

You are given two sequences of integer numbers. You are to find their longest common increasing subsequence, i.e. an increasing sequence of maximum length that is the subsequence of both sequences.

Input

The first line contains an integer n (1 ≤ n ≤ 500) — the length of the first sequence. The second line contains n space-separated integers from the range [0, 109] — elements of the first sequence. The third line contains an integer m (1 ≤ m ≤ 500) — the length of the second sequence. The fourth line contains m space-separated integers from the range [0, 109] — elements of the second sequence.

Output

In the first line output k — the length of the longest common increasing subsequence. In the second line output the subsequence itself. Separate the elements with a space. If there are several solutions, output any.

Sample Input

7
2 3 1 6 5 4 6
4
1 3 5 6

Sample Output

3
3 5 6

Hint

题意

给你两个串,求公共最长上升子序列

题解:

考虑暴力枚举第一个串,然后for循环枚举第二个串

dp[i]表示第二个串位置为i的时候与第一个串的的最长公共上升子序列是多少

然后直接暴力更新dp就好了

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 505;
int dp[maxn],a[maxn],b[maxn],step[maxn],n,m;
void print(int x)
{
    if(x==0)return;
    print(step[x]);
    printf("%d ",b[x]);
}
int main()
{
    scanf("%d",&n);for(int i=1;i<=n;i++)scanf("%d",&a[i]);
    scanf("%d",&m);for(int i=1;i<=m;i++)scanf("%d",&b[i]);

    for(int i=1;i<=n;i++)
    {
        int pos = 0;
        for(int j=1;j<=m;j++)
        {
            if(a[i]==b[j])
            {
                dp[j]=dp[pos]+1;
                step[j]=pos;
            }
            else if(a[i]>b[j]&&dp[pos]<dp[j])
                pos=j;
        }
    }
    int ans = 0,ans1 = 0;
    for(int i=1;i<=m;i++)
        if(dp[i]>ans1)
            ans1=dp[i],ans=i;
    cout<<ans1<<endl;
    print(ans);
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值